Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StringExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StringExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StringExpressions.cs	(revision 15017)
@@ -1,4 +1,5 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using System;
+  using System.Globalization;
   using System.Linq;
 
@@ -6,4 +7,5 @@
 
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
 
   using Interpreter;
@@ -40,5 +42,7 @@
     public override void Eval(IInternalPushInterpreter interpreter) {
       var value = interpreter.FloatStack.Pop();
-      interpreter.StringStack.Push(value.ToString());
+      var str = value.ToString(interpreter.Configuration.FloatStringFormat, CultureInfo.InvariantCulture);
+
+      interpreter.StringStack.Push(str);
     }
   }
@@ -92,5 +96,5 @@
     public override void Eval(IInternalPushInterpreter interpreter) {
       var str = interpreter.StringStack.Pop();
-      interpreter.StringStack.SetTop(str + interpreter.StringStack.Top);
+      interpreter.StringStack.Top += str;
     }
   }
@@ -114,5 +118,5 @@
     public override void Eval(IInternalPushInterpreter interpreter) {
       var c = interpreter.CharStack.Pop();
-      interpreter.StringStack.SetTop(interpreter.StringStack.Top + c);
+      interpreter.StringStack.Top += c;
     }
   }
@@ -131,5 +135,4 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      var value = interpreter.IntegerStack.Pop();
       var str = interpreter.StringStack.Top;
 
@@ -137,6 +140,6 @@
         return;
 
-      value = Math.Abs(value) % str.Length;
-      interpreter.StringStack.SetTop(str.Substring(0, (int)value));
+      var endIndex = interpreter.IntegerStack.Pop().AsInt(str.Length);
+      interpreter.StringStack.Top = str.Substring(0, endIndex);
     }
   }
@@ -165,5 +168,5 @@
 
       if (length > 0)
-        interpreter.StringStack.SetTop(str.Substring((int)first, (int)length));
+        interpreter.StringStack.Top = str.Substring((int)first, (int)length);
     }
   }
@@ -182,5 +185,5 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      interpreter.StringStack.SetTop(interpreter.StringStack.Top[0].ToString());
+      interpreter.StringStack.Top = interpreter.StringStack.Top[0].ToString();
     }
   }
@@ -201,5 +204,5 @@
       var str = interpreter.StringStack.Top;
       var c = str[str.Length - 1].ToString();
-      interpreter.StringStack.SetTop(c);
+      interpreter.StringStack.Top = c;
     }
   }
@@ -220,7 +223,7 @@
     public override void Eval(IInternalPushInterpreter interpreter) {
       var str = interpreter.StringStack.Top;
-      var index = str.Length == 1 ? 0 : (int)Math.Abs(interpreter.IntegerStack.Pop()) % str.Length;
+      var index = str.Length == 1 ? 0 : interpreter.IntegerStack.Pop().AsInt(str.Length);
       var c = str[index].ToString();
-      interpreter.StringStack.SetTop(c);
+      interpreter.StringStack.Top = c;
     }
   }
@@ -240,5 +243,5 @@
     public override void Eval(IInternalPushInterpreter interpreter) {
       var str = interpreter.StringStack.Top;
-      interpreter.StringStack.SetTop(str.Length == 1 ? string.Empty : str.Substring(1, str.Length - 1));
+      interpreter.StringStack.Top = str.Length == 1 ? string.Empty : str.Substring(1, str.Length - 1);
     }
   }
@@ -258,5 +261,5 @@
     public override void Eval(IInternalPushInterpreter interpreter) {
       var str = interpreter.StringStack.Top;
-      interpreter.StringStack.SetTop(str.Length == 1 ? string.Empty : str.Substring(0, str.Length - 1));
+      interpreter.StringStack.Top = str.Length == 1 ? string.Empty : str.Substring(0, str.Length - 1);
     }
   }
@@ -287,9 +290,11 @@
 
     public override bool IsNoop(IInternalPushInterpreter interpreter) {
-      return interpreter.StringStack.IsEmpty;
-    }
-
-    public override void Eval(IInternalPushInterpreter interpreter) {
-      interpreter.StringStack.SetTop(interpreter.StringStack.Top.Reverse().ToString());
+      return interpreter.StringStack.IsEmpty || interpreter.StringStack.Top.Length <= 1;
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      var chars = interpreter.StringStack.Top.ToArray();
+      Array.Reverse(chars);
+      interpreter.StringStack.Top = new string(chars);
     }
   }
@@ -313,5 +318,5 @@
 
       var str = interpreter.StringStack.Top;
-      interpreter.StringStack.SetTop(str[0].ToString());
+      interpreter.StringStack.Top = str[0].ToString();
 
       if (str.Length > 1) {
@@ -334,13 +339,21 @@
 
     public override bool IsNoop(IInternalPushInterpreter interpreter) {
-      return interpreter.StringStack.IsEmpty ||
-             interpreter.StringStack.Top.Trim().Split().Length <= 1;
-    }
-
-    public override void Eval(IInternalPushInterpreter interpreter) {
-      var words = interpreter.StringStack.Top.Trim().Split();
-
-      interpreter.StringStack.SetTop(words[0]);
-      interpreter.StringStack.Push(words, 1);
+      return interpreter.StringStack.IsEmpty;
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      var words = interpreter.StringStack.Top
+        .Trim()
+        .Split()
+        .Where(x => !string.IsNullOrWhiteSpace(x))
+        .Reverse()
+        .ToArray();
+
+      if (words.Length == 0) {
+        interpreter.StringStack.Pop();
+      } else {
+        interpreter.StringStack.Top = words[0];
+        interpreter.StringStack.Push(words, 1);
+      }
     }
   }
@@ -439,5 +452,5 @@
   /// </summary>
   [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.OCCURENCESOFCHAR", StackTypes.Integer | StackTypes.Char)]
+  [PushExpression(StackTypes.String, "STRING.OCCURRENCESOFCHAR", StackTypes.Integer | StackTypes.Char)]
   public class StringOccurrencesOfCharExpression : StatelessExpression {
     public StringOccurrencesOfCharExpression() { }
@@ -477,26 +490,24 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      var first = interpreter.StringStack[1];
-      var second = interpreter.StringStack.Top;
+      var third = interpreter.StringStack[2];
+      var second = interpreter.StringStack[1];
+      var first = interpreter.StringStack[0];
       interpreter.StringStack.Remove(2);
 
-      if (first.Length == 0 || second.Length == 0)
-        interpreter.StringStack.SetTop(first);
-      else {
-        var result = first.Replace(second, interpreter.StringStack.Top);
-        interpreter.StringStack.SetTop(result);
-      }
-    }
-  }
-
-  /// <summary>
-  /// In third string on stack, replaces first occurence of second string with first string
+      interpreter.StringStack.Top = third.Length == 0 || second.Length == 0
+        ? third
+        : third.Replace(second, first);
+    }
+  }
+
+  /// <summary>
+  /// In third string on stack, replaces first occurrence of second string with first string
   /// </summary>
   [StorableClass]
   [PushExpression(StackTypes.String, "STRING.REPLACEFIRST")]
-  public class StringReplaceLastExpression : StatelessExpression {
-    public StringReplaceLastExpression() { }
-    [StorableConstructor]
-    protected StringReplaceLastExpression(bool deserializing) : base(deserializing) { }
+  public class StringReplaceFirstExpression : StatelessExpression {
+    public StringReplaceFirstExpression() { }
+    [StorableConstructor]
+    protected StringReplaceFirstExpression(bool deserializing) : base(deserializing) { }
 
     public override bool IsNoop(IInternalPushInterpreter interpreter) {
@@ -505,24 +516,22 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
+      var third = interpreter.StringStack[2];
+      var second = interpreter.StringStack[1];
       var first = interpreter.StringStack[0];
-      var second = interpreter.StringStack[1];
-      var third = interpreter.StringStack[2];
       interpreter.StringStack.Remove(2);
 
-      var result = ReplaceFirst(third, second, first);
-      interpreter.StringStack.SetTop(result);
+      interpreter.StringStack.Top = third.Length == 0 || second.Length == 0
+        ? third
+        : ReplaceFirst(third, second, first);
     }
 
     private static string ReplaceFirst(string text, string search, string replace) {
-      int pos = text.IndexOf(search);
-      if (pos < 0) {
-        return text;
-      }
-      return text.Substring(0, pos) + replace + text.Substring(pos + search.Length);
-    }
-  }
-
-  /// <summary>
-  /// In top string on stack, replaces all occurences of second char with first char
+      var pos = text.IndexOf(search, StringComparison.Ordinal);
+      return pos < 0 ? text : text.Substring(0, pos) + replace + text.Substring(pos + search.Length);
+    }
+  }
+
+  /// <summary>
+  /// In top string on stack, replaces all occurrences of second char with first char
   /// </summary>
   [StorableClass]
@@ -544,17 +553,17 @@
 
       var result = interpreter.StringStack.Top.Replace(first, second);
-      interpreter.StringStack.SetTop(result);
-    }
-  }
-
-  /// <summary>
-  /// In top string on stack, replaces first occurence of second char with first char
+      interpreter.StringStack.Top = result;
+    }
+  }
+
+  /// <summary>
+  /// In top string on stack, replaces first occurrence of second char with first char
   /// </summary>
   [StorableClass]
   [PushExpression(StackTypes.String, "STRING.REPLACEFIRSTCHAR", StackTypes.Char)]
-  public class StringReplaceLastCharExpression : StatelessExpression {
-    public StringReplaceLastCharExpression() { }
-    [StorableConstructor]
-    protected StringReplaceLastCharExpression(bool deserializing) : base(deserializing) { }
+  public class StringReplaceFirstCharExpression : StatelessExpression {
+    public StringReplaceFirstCharExpression() { }
+    [StorableConstructor]
+    protected StringReplaceFirstCharExpression(bool deserializing) : base(deserializing) { }
 
     public override bool IsNoop(IInternalPushInterpreter interpreter) {
@@ -576,12 +585,12 @@
       var result = str.Substring(0, pos) +
                    second +
-                   str.Substring(Math.Min(pos + 2, str.Length - 1));
-
-      interpreter.StringStack.SetTop(result);
-    }
-  }
-
-  /// <summary>
-  /// In top string on stack, remove all occurences of char
+                   str.Substring(Math.Min(pos + 1, str.Length - 1));
+
+      interpreter.StringStack.Top = result;
+    }
+  }
+
+  /// <summary>
+  /// In top string on stack, remove all occurrences of char
   /// </summary>
   [StorableClass]
@@ -600,10 +609,10 @@
       var c = interpreter.CharStack.Pop();
       var result = interpreter.StringStack.Top.Trim(c);
-      interpreter.StringStack.SetTop(result);
-    }
-  }
-
-  /// <summary>
-  /// Returns a function that sets char at index in string
+      interpreter.StringStack.Top = result;
+    }
+  }
+
+  /// <summary>
+  /// Sets char at index in string
   /// </summary>
   [StorableClass]
@@ -622,16 +631,53 @@
     public override void Eval(IInternalPushInterpreter interpreter) {
       var str = interpreter.StringStack.Top;
-      var i = (int)interpreter.IntegerStack.Pop();
       var c = interpreter.CharStack.Pop();
-
-      if (str.Length == 0) {
-        interpreter.StringStack.Pop();
+      var x = interpreter.IntegerStack.Pop();
+
+      if (str.Length == 0) return;
+      if (str.Length == 1) {
+        interpreter.StringStack.Top = c.ToString();
         return;
       }
 
-      var pos = str.Length == 1 ? 0 : Math.Abs(i) % (str.Length - 1);
-      var result = str.Substring(0, pos) + c + str.Substring(Math.Min(pos + 2, str.Length - 1));
-
-      interpreter.StringStack.SetTop(result);
+      var pos = x.AsInt(str.Length);
+      var result = str.Substring(0, pos) + c + str.Substring(Math.Min(pos + 1, str.Length - 1));
+
+      interpreter.StringStack.Top = result;
+    }
+  }
+
+  /// <summary>
+  /// Iterates over a string using the code on the exec stack.
+  /// </summary>
+  [StorableClass]
+  [PushExpression(StackTypes.String, "STRING.ITERATE", StackTypes.Exec | StackTypes.Char, execIn: 1)]
+  public class StringIterateExpression : StatelessExpression {
+    public StringIterateExpression() { }
+    [StorableConstructor]
+    protected StringIterateExpression(bool deserializing) : base(deserializing) { }
+
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      return interpreter.StringStack.IsEmpty ||
+             interpreter.ExecStack.IsEmpty;
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      var str = interpreter.StringStack.Pop();
+
+      if (str.Length == 0) {
+        interpreter.ExecStack.Pop();
+      }
+      // If the rest of the string is empty, we're done iterating.
+      else if (str.Length == 1) {
+        interpreter.CharStack.Push(str[0]);
+      } else {
+        var pool = interpreter.PoolContainer.GetStatefulExpressionPool<StringPushExpression>();
+
+        interpreter.CharStack.Push(str[0]);
+        interpreter.ExecStack.Push(
+          this,
+          StringPushExpression.Create(pool, str.Substring(1)),
+          interpreter.ExecStack.Top);
+      }
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs	(revision 15017)
@@ -88,5 +88,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.SWAP")]
+  [PushExpression(StackTypes.Exec, "EXEC.SWAP", execIn: 2)]
   public class ExecSwapExpression : SwapExpression<Expression> {
     public ExecSwapExpression() { }
@@ -153,5 +153,5 @@
   [StorableClass]
   [PushExpression(StackTypes.IntegerVector, "INTEGER[].SWAP")]
-  public class IntegerVectorSwapExpression : SwapExpression<List<long>> {
+  public class IntegerVectorSwapExpression : SwapExpression<IReadOnlyList<long>> {
     public IntegerVectorSwapExpression() { }
     [StorableConstructor]
@@ -169,5 +169,5 @@
   [StorableClass]
   [PushExpression(StackTypes.FloatVector, "FLOAT[].SWAP")]
-  public class FloatVectorSwapExpression : SwapExpression<List<double>> {
+  public class FloatVectorSwapExpression : SwapExpression<IReadOnlyList<double>> {
     public FloatVectorSwapExpression() { }
     [StorableConstructor]
@@ -185,5 +185,5 @@
   [StorableClass]
   [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].SWAP")]
-  public class BooleanVectorSwapExpression : SwapExpression<List<bool>> {
+  public class BooleanVectorSwapExpression : SwapExpression<IReadOnlyList<bool>> {
     public BooleanVectorSwapExpression() { }
     [StorableConstructor]
@@ -201,5 +201,5 @@
   [StorableClass]
   [PushExpression(StackTypes.StringVector, "STRING[].SWAP")]
-  public class StringVectorSwapExpression : SwapExpression<List<string>> {
+  public class StringVectorSwapExpression : SwapExpression<IReadOnlyList<string>> {
     public StringVectorSwapExpression() { }
     [StorableConstructor]
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorButLastExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorButLastExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorButLastExpressions.cs	(revision 15017)
@@ -1,4 +1,5 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using System.Collections.Generic;
+  using System.Linq;
 
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -17,11 +18,12 @@
     protected VectorButLastExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IPushStack<List<T>> vectorStack) {
+    protected bool IsNoop(IPushStack<IReadOnlyList<T>> vectorStack) {
       return vectorStack.IsEmpty || vectorStack.Top.Count < 2;
     }
 
-    protected void Eval(IPushStack<List<T>> vectorStack) {
-      var result = vectorStack.Top.GetRange(0, vectorStack.Top.Count - 1);
-      vectorStack.SetTop(result);
+    protected void Eval(IPushStack<IReadOnlyList<T>> vectorStack) {
+      vectorStack.Top = vectorStack.Top
+        .Take(vectorStack.Top.Count - 1)
+        .ToArray();
     }
   }
@@ -76,5 +78,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "String[].BUTLAST")]
+  [PushExpression(StackTypes.StringVector, "STRING[].BUTLAST")]
   public class StringVectorButLastExpression : VectorButLastExpression<string> {
     public StringVectorButLastExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConcatExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConcatExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConcatExpressions.cs	(revision 15017)
@@ -16,17 +16,17 @@
     protected VectorConcatExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IInternalPushInterpreter interpreter, IPushStack<List<T>> vectorStack) {
+    protected bool IsNoop(IInternalPushInterpreter interpreter, IPushStack<IReadOnlyList<T>> vectorStack) {
       return vectorStack.Count < 2 ||
              vectorStack.Top.Count + vectorStack[1].Count > interpreter.Configuration.MaxVectorLength;
     }
 
-    protected void Eval(IInternalPushInterpreter interpter, IPushStack<List<T>> vectorStack) {
+    protected void Eval(IInternalPushInterpreter interpter, IPushStack<IReadOnlyList<T>> vectorStack) {
       var first = vectorStack.Pop();
       var second = vectorStack.Top;
-      var result = new T[first.Count + second.Count];
+      var result = new List<T>(second.Count + first.Count);
+      result.AddRange(second);
+      result.AddRange(first);
 
-      first.CopyTo(result, 0);
-      second.CopyTo(result, first.Count);
-      vectorStack.SetTop(new List<T>(result));
+      vectorStack.Top = result;
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConjExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConjExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConjExpressions.cs	(revision 15017)
@@ -16,5 +16,5 @@
     protected VectorConjExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IInternalPushInterpreter interpreter, IPushStack<List<T>> vectorStack, IPushStack<T> literalStack) {
+    protected bool IsNoop(IInternalPushInterpreter interpreter, IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
       return vectorStack.IsEmpty ||
              literalStack.IsEmpty ||
@@ -22,7 +22,7 @@
     }
 
-    protected void Eval(IInternalPushInterpreter interpreter, IPushStack<List<T>> vectorStack, IPushStack<T> literalStack) {
+    protected void Eval(IInternalPushInterpreter interpreter, IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
       var literal = literalStack.Pop();
-      vectorStack.Top.Add(literal);
+      vectorStack.Top = new List<T>(vectorStack.Top) { literal };
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorContainsExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorContainsExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorContainsExpressions.cs	(revision 15017)
@@ -2,4 +2,6 @@
 
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using System.Linq;
+
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
@@ -17,14 +19,14 @@
     protected VectorContainsExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IPushStack<List<T>> vectorStack, IPushStack<T> literalStack) {
+    protected bool IsNoop(IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
       return vectorStack.IsEmpty || literalStack.IsEmpty;
     }
 
-    protected void Eval(IInternalPushInterpreter interpreter, IPushStack<List<T>> vectorStack, IPushStack<T> literalStack, bool canOverride = false) {
+    protected void Eval(IInternalPushInterpreter interpreter, IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack, bool canOverride = false) {
       var vector = vectorStack.Pop();
       var literal = canOverride ? literalStack.Top : literalStack.Pop();
       var contains = vector.Contains(literal);
 
-      if (canOverride) interpreter.BooleanStack.SetTop(contains);
+      if (canOverride) interpreter.BooleanStack.Top = contains;
       else interpreter.BooleanStack.Push(contains);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorEmptyExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorEmptyExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorEmptyExpressions.cs	(revision 15017)
@@ -17,9 +17,9 @@
     protected VectorEmptyVectorExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IPushStack<List<T>> vectorStack) {
+    protected bool IsNoop(IPushStack<IReadOnlyList<T>> vectorStack) {
       return vectorStack.IsEmpty;
     }
 
-    protected void Eval(IInternalPushInterpreter interpreter, IPushStack<List<T>> vectorStack) {
+    protected void Eval(IInternalPushInterpreter interpreter, IPushStack<IReadOnlyList<T>> vectorStack) {
       var vector = vectorStack.Pop();
       interpreter.BooleanStack.Push(vector.Count == 0);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorFirstExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorFirstExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorFirstExpressions.cs	(revision 15017)
@@ -17,9 +17,9 @@
     protected VectorFirstExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IPushStack<List<T>> vectorStack) {
+    protected bool IsNoop(IPushStack<IReadOnlyList<T>> vectorStack) {
       return vectorStack.IsEmpty || vectorStack.Top.Count == 0;
     }
 
-    protected void Eval(IPushStack<List<T>> vectorStack, IPushStack<T> literalStack) {
+    protected void Eval(IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
       var vector = vectorStack.Pop();
       literalStack.Push(vector[0]);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIndexOfExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIndexOfExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIndexOfExpressions.cs	(revision 15017)
@@ -17,5 +17,5 @@
     protected VectorIndexOfExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IPushStack<List<T>> vectorStack, IPushStack<T> literalStack) {
+    protected bool IsNoop(IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
       return vectorStack.IsEmpty || literalStack.IsEmpty;
     }
@@ -23,13 +23,20 @@
     protected void Eval(
       IInternalPushInterpreter interpreter,
-      IPushStack<List<T>> vectorStack,
+      IPushStack<IReadOnlyList<T>> vectorStack,
       IPushStack<T> literalStack,
       bool canOverride = false) {
       var vector = vectorStack.Pop();
       var literal = canOverride ? literalStack.Top : literalStack.Pop();
-      var result = vector.IndexOf(literal);
 
-      if (canOverride) interpreter.IntegerStack.SetTop(result);
-      else interpreter.IntegerStack.Push(result);
+      var index = -1;
+      for (var i = 0; i < vector.Count && index < 0; i++) {
+        if (vector[i].Equals(literal)) {
+          index = i;
+          break;
+        }
+      }
+
+      if (canOverride) interpreter.IntegerStack.Top = index;
+      else interpreter.IntegerStack.Push(index);
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIterateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIterateExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIterateExpressions.cs	(revision 15017)
@@ -2,4 +2,7 @@
 
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using System;
+  using System.Linq;
+
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
@@ -18,9 +21,9 @@
     protected VectorIterateExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IInternalPushInterpreter interpter, IPushStack<List<T>> vectorStack) {
+    protected bool IsNoop(IInternalPushInterpreter interpter, IPushStack<IReadOnlyList<T>> vectorStack) {
       return vectorStack.IsEmpty || interpter.ExecStack.IsEmpty;
     }
 
-    protected void Eval(IInternalPushInterpreter interpter, IPushStack<List<T>> vectorStack, IPushStack<T> literalStack) {
+    protected void Eval(IInternalPushInterpreter interpter, IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
       var vector = vectorStack.Top;
 
@@ -36,5 +39,22 @@
         var last = vector.Count - 1;
         literalStack.Push(vector[last]);
-        vector.RemoveAt(last);
+
+        var list = vector as List<T>;
+        if (list != null) {
+          var newTop = new T[last];
+          list.CopyTo(0, newTop, 0, last);
+          vectorStack.Top = newTop;
+          return;
+        }
+
+        var array = vector as T[];
+        if (array != null) {
+          var newTop = new T[last];
+          Array.Copy(array, 0, newTop, 0, last);
+          vectorStack.Top = newTop;
+          return;
+        }
+
+        vectorStack.Top = vector.Take(last).ToArray();
       }
     }
@@ -42,5 +62,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].ITERATE", StackTypes.Integer | StackTypes.Exec)]
+  [PushExpression(StackTypes.IntegerVector, "INTEGER[].ITERATE", StackTypes.Integer | StackTypes.Exec, execIn: 1)]
   public class IntegerVectorIterateExpression : VectorIterateExpression<long> {
     public IntegerVectorIterateExpression() { }
@@ -58,5 +78,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].ITERATE", StackTypes.Float | StackTypes.Exec)]
+  [PushExpression(StackTypes.FloatVector, "FLOAT[].ITERATE", StackTypes.Float | StackTypes.Exec, execIn: 1)]
   public class FloatVectorIterateExpression : VectorIterateExpression<double> {
     public FloatVectorIterateExpression() { }
@@ -74,5 +94,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].ITERATE", StackTypes.Boolean | StackTypes.Exec)]
+  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].ITERATE", StackTypes.Boolean | StackTypes.Exec, execIn: 1)]
   public class BooleanVectorIterateExpression : VectorIterateExpression<bool> {
     public BooleanVectorIterateExpression() { }
@@ -90,5 +110,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].ITERATE", StackTypes.String | StackTypes.Exec)]
+  [PushExpression(StackTypes.StringVector, "STRING[].ITERATE", StackTypes.String | StackTypes.Exec, execIn: 1)]
   public class StringVectorIterateExpression : VectorIterateExpression<string> {
     public StringVectorIterateExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLastExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLastExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLastExpressions.cs	(revision 15017)
@@ -17,9 +17,9 @@
     protected VectorLastExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IPushStack<List<T>> vectorStack) {
+    protected bool IsNoop(IPushStack<IReadOnlyList<T>> vectorStack) {
       return vectorStack.IsEmpty || vectorStack.Top.Count == 0;
     }
 
-    protected void Eval(IPushStack<List<T>> vectorStack, IPushStack<T> literalStack) {
+    protected void Eval(IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
       var vector = vectorStack.Pop();
       literalStack.Push(vector[vector.Count - 1]);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLengthExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLengthExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLengthExpressions.cs	(revision 15017)
@@ -17,9 +17,9 @@
     protected VectorLengthExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IPushStack<List<T>> vectorStack) {
+    protected bool IsNoop(IPushStack<IReadOnlyList<T>> vectorStack) {
       return vectorStack.IsEmpty;
     }
 
-    protected void Eval(IInternalPushInterpreter interpreter, IPushStack<List<T>> vectorStack) {
+    protected void Eval(IInternalPushInterpreter interpreter, IPushStack<IReadOnlyList<T>> vectorStack) {
       var length = vectorStack.Pop().Count;
       interpreter.IntegerStack.Push(length);
